package org.fuseri.modulelanguageschool.user;

import jakarta.persistence.ElementCollection;
import jakarta.persistence.Embedded;
import jakarta.persistence.Entity;
import jakarta.persistence.EnumType;
import jakarta.persistence.Enumerated;
import jakarta.persistence.JoinColumn;
import jakarta.persistence.JoinTable;
import jakarta.persistence.ManyToMany;
import jakarta.persistence.Table;
import org.fuseri.model.dto.user.Language;
import org.fuseri.model.dto.user.ProficiencyLevel;
import org.fuseri.modulelanguageschool.common.DomainObject;
import lombok.*;
import org.fuseri.modulelanguageschool.course.Course;

import java.util.Map;
import java.util.Set;

@Getter
@Setter
@Entity
@Builder
@NoArgsConstructor
@AllArgsConstructor
@Table(name = "domain_user")
public class User extends DomainObject {

    private String username;

    @Enumerated(EnumType.STRING)
    private UserType userType;

    private String password;

    private String email;

    private String firstName;

    private String lastName;

    @Embedded
    private Address address;

    @ManyToMany
    @JoinTable(name = "myCourses",
    joinColumns = @JoinColumn(name = "studentId"),
            inverseJoinColumns = @JoinColumn(name = "courseId")
    )
    private Set<Course> courses;

    @ElementCollection
    private Map<Language,ProficiencyLevel> languageProficiency;
}